#  Author: Audris Mockus
#  (C) Copyright (2000) by Lucent Technologies Inc.  All rights reserved.
#  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF LUCENT TECHNOLOGIES.
#  The copyright notice above does not evidence any actual
#  or intended publication of such source code.

#
#group delta into commits based on submitter, time window and comment
#
$i=0;
while (<STDIN>){
	if (!(($i++)%10000)){ print STDERR "$i delta read\n"; }
	chop ($_);
	($f,$mod,$rev,$vv,$ymd,$stmp,$a,$nadd,$ndel,$submitted,$reviewed,$log)=split(/\;/, $_);
	$content="$f\;$mod\;$rev\;$vv\;$ymd\;$stmp\;$nadd\;$ndel";
	
	$stmp1=int($stmp/$ARGV[0])*$ARGV[0]; # group by one minute resolution
	$key="$a\;$stmp1\;$log";
	$changes{$key}{$content}++;
}

foreach $key (keys %changes){
	@deltas=keys %{ $changes{$key} };
	print "$key\;".(scalar(@deltas));
	if (scalar(@deltas) > 0){
		foreach $delta (@deltas){
			print "\;$delta";
		}
	}
	print "\n";	 
}



