sub procmod {
	local($mod)=$_[0];
	if ($mod eq "apache-api"
   	|| $mod eq "protocol"
   	|| $mod eq "config"
   	|| $mod eq "general"
   	|| $mod eq "other"
   	|| $mod eq "mod_dld"
		 || $mod eq "mod_so") { $mod = "core";}
	if ($mod eq "mod_access" ||
   $mod eq "mod_actions" ||
   $mod eq "mod_alias" ||
   $mod eq "mod_asis" ||
   $mod eq "mod_auth-any" ||
   $mod eq "mod_autoindex" ||
   $mod eq "mod_browser" ||
   $mod eq "mod_cgi" ||
   $mod eq "mod_dir" ||
   $mod eq "mod_env" ||
   $mod eq "mod_imap" ||
   $mod eq "mod_include" ||
   $mod eq "mod_log-any" ||
   $mod eq "mod_mime" ||
   $mod eq "mod_setenvif" ||
   $mod eq "mod_status" ||
		 $mod eq "mod_userdir"){
		 $mod = "most sites";}
	if ($mod eq "mod_negotiation" ||
	   $mod eq "mod_proxy" ||
		$mod eq "mod_jserv" ||
		 $mod eq "mod_perl" ||
		 $mod eq "mod_rewrite"

		 ){
		$mod = "major optional";}
	if ($mod eq "mod_cern_meta" ||
   	$mod eq "mod_cookie" ||
	   $mod eq "mod_digest" ||
  	 $mod eq "mod_expires" ||
  	 $mod eq "mod_info" ||
  	 $mod eq "mod_headers" ||
  	 $mod eq "mod_speling" ||
  	 $mod eq "mod_usertrack" ||
		 $mod eq "suexec"){
		$mod="Miscellaneous features"}
	if ($mod =~ /^os/){ $mod="os";}
	if ($mod eq "test" || $mod eq "pending") { $mod="junk";}
	$mod;
}


while(<STDIN>){
	chomp();
	($pr,$changed,$o,$c,$mod,$open,$name,$mod1,$stat)=split(/\;/);
	if ($mod ne $mod1){
		#print STDERR "$pr,$mod,$mod1\n";
	}
	
	if ($open =~ /:/){			
		$mod=&procmod($mod);
   	$mod1=&procmod($mod1);
	   ($open,$pri,$sev)=split(/\:/,$open);
		$stat=~s/[a-z]*-closed$/closed/;
		$stat=~s/[^\;]*medium$/not closed/;
		if ($stat eq "") { $stat = "not closed";}
		print "$pr\;$changed\;$o\;$c\;$mod\;$open\;$pri\;$sev\;$name\;$mod1\;$stat\n";
	}
}
	
