open A, "mailfixmrs";

sub fixName {
	local($n)=@_[0];	
	$n=~s/   \./\./g;
	$n=~s/  \./\./g;
	$n=~s/ \./\./g;
	$n=~s/^   //g;
	$n=~s/^  //g;
	$n=~s/^ //g;
	if ($n eq "rbb" || $n eq "rbb\@hyperreal.org") { $n="David Reid";}
	if ($n eq "paul" || $n eq "rbb\@hyperreal.org") { $n="Paul Richards";}
	if ($n eq "ben" || $n eq "Ben"|| $n eq "ben\@hyperreal.org") { $n="Ben Laurie";}
	if ($n eq "mjc" || $n eq "mjc\@hyperreal.org" || $n eq "Mark J Cox") { $n="Mark Cox";}
	if ($n eq "jim" || $n eq "jim\@hyperreal.org") { $n="Jim Jagielski";}
	if ($n eq "akosut"|| $n eq "akosut\@hyperreal.org"|| $n eq "Alexei") { $n="Alexei Kosut";}
	if ($n eq "brian" || $n eq "brian\@hyperreal.org") { $n="Brian Behlendorf";}
	if ($n eq "chuck" || $n eq "chuck\@hyperreal.org") { $n="Chuck Murcko";}
	
	if ($n eq "fielding" || $n eq "fielding\@hyperreal.org" || $n eq "Roy T. Fielding") { $n="Roy Fielding";}
	
   if ($n eq "dgaudet" || $n eq "dgaudet\@hyperreal.org"){ $n="Dean Gaudet";}

   if ($n eq "rse" || $n eq "rse\@hyperreal.org" || $n eq "Ralf Engelschall" || $n eq "Ralf S . Engelschall" || $n eq "Ralf" || $n eq "Ralf S . Engelschal"){ $n="Ralf S. Engelschall";}
	if ($n eq "coar" || $n eq "coar\@hyperreal.org" ||
		 $n =~ /Rodent Of Unusual Size/ || $n eq "Ken the Rodent of Unusual Size"){       
		$n="Ken Coar";
	}
	if ($n eq "pcs" || $n eq "pcs\@hyperreal.org") { $n="Paul Sutton";}
	if ($n eq "marc" || $n eq "mark slemko"||$n eq "marc slemko"|| $n eq "comments from marc slemko" || $n eq "based on marc slemko's patch" || $n eq "marc\@hyperreal.org"){ $n="Marc Slemko";}
	if ($n eq "manoj" || $n eq "manoj\@hyperreal.org"){ $n="Manoj Kasichainula";}
	if ($n eq "randy" || $n eq "randy\@hyperreal.org"){ $n="Randy Terbush";}
	if ($n eq "dougm" || $n =~ /dougm\@.*hyperreal.org/ || $n eq "Doug MacEachern"){ $n="Doug Maceachern";}
	if ($n eq "sameer" || $n eq "sameer\@hyperreal.org"){ $n="Sameer Parekh";}
	if ($n eq "lars" || $n eq "lars\@hyperreal.org"){ $n="Lars Eilebrecht";}
	if ($n eq "martin" || $n eq "martin\@hyperreal.org"){ $n="Martin Kraemer";}
	if ($n eq "stoddard" || $n eq "stoddard\@hyperreal.org"){ $n="Bill Stoddard";}
	if ($n eq "rasmus" || $n eq "rasmus\@hyperreal.org"){ $n="Rasmus Lerdorf";}
	if ($n eq "wsanchez" || $n eq "wsanchez\@hyperreal.org"){ $n="Wilfredo Sanchez";}
	if ($n eq "dirkx" || $n eq "dirkx\@hyperreal.org" || $n eq "Dirk.Vangulik" || $n eq "Dirk vanGulik" || $n eq "Dirk-Willem Van Gulik"|| $n eq "Dirk . Vangulik"){ $n="Dirk-Willem van Gulik";}
	if ($n eq "bhyde" || $n =~ /bhyde\@/){ $n="Ben Hyde";}
	if ($n eq "hartill\@hyperreal.org"){ $n="Rob Hartill";}
	if ($n eq "cliff\@hyperreal.org"){ $n="Cliff Skolnick";}
	if ($n eq "gstein\@hyperreal.org"){ $n="Greg Stein";}
	if ($n eq "" || $n eq ""){ $n="";}
	if ($n eq "" || $n eq ""){ $n="";}
	if ($n eq "" || $n eq ""){ $n="";}
	$n;  
}

while(<A>){
  	@x=split(/\;/);
	@submitters=split(/\|/, $x[11]);
	$prs="no";
	if ($x[10] ne "") {$prs="yes";}
	$check=$x[8];
	
	if (scalar(@submitters) > 0){
		foreach $i (@submitters){
			($name,$email)=split(/:/,$i);			
			print "$x[0]\;$x[1]\;$x[2]\;$x[3]\;$x[4]\;$x[5]\;$x[6]\;$x[7]\;$prs\;";
			if ($name ne ""){
				
				print &fixName($name)."\n";
			}else{
				print &fixName($email)."\n";
			}
		}
	}else{
		print "$x[0]\;$x[1]\;$x[2]\;$x[3]\;$x[4]\;$x[5]\;$x[6]\;$x[7]\;$prs\;";
		if ($check ne ""){
			print &fixName($check)."\n";
		}else{
			print &fixName($x[9])."\n";
		}
	}
}
		
	
	

